/*****************************************************************************
**
** program_ugnx3_move_instance.cpp
**
** Description:
**     Contains Unigraphics entry points for the application.


27  2006   ..
      
    -  FPDF 
          
    


	//1.	  <disp_part>  
	//2.	  ,      
	//     <UF_UI_select_with_class_dialog>
	//      <component_init_proc>
	//    <rivet_attr>  
	//    <rivet>
	//3.	  - ,      
	//     <UF_UI_select_with_single_dialog>
	//      <path_init_proc>
	//    <no_rivet_attr>  
	//    <rivet>
	//    ,    ,
	//  
	//      
	//  
	//4.	     
	//5.	  -    
	//6.	    - 
	//7.	     
	//   <rivet>  
	//---------------  --------------------------------




**
*****************************************************************************/

/* Include files */
#if ! defined ( __hp9000s800 ) && ! defined ( __sgi ) && ! defined ( __sun )
#   include <strstream>
#   include <iostream>
    using std::ostrstream;
    using std::endl;    
    using std::ends;
    using std::cerr;
#else
#   include <strstream.h>
#   include <iostream.h>
#endif



#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>


FILE*		prterr;
int			errorCode;


#define	PRTERR(line)if(errorCode)\
	{PrintErrorMessage(errorCode,line);errorCode=0;goto term;}
#define	FREE_OBJ(object)\
	if(object)\
		for(i=0;i<count;i++)\
		{\
			errorCode=UF_DISP_set_highlight(object[i],0);\
			PRTERR(__LINE__);\
		}\
	UF_free(object);


static void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"errorCode=%d	message=%s		line=%d	\n",
			errorCode,message,line);
	}
}

//     rivet
static int rivet_attr(    
	tag_t object,
    int type[3],
    void *user_data,
    UF_UI_selection_p_t select)
{
	int
		indx,
		attr_type=UF_ATTR_string;
	char
		title[100];
	UF_ATTR_value_t
		value;
	static char
		rivet_type[300];

	value.value.string=rivet_type;

	indx=0;
	errorCode=UF_ATTR_cycle(object,&indx,attr_type,title,&value );
	PRTERR(__LINE__);
	
	while(indx)
	{
		if(strcmp(title,"RIVET")==0)
			return UF_UI_SEL_ACCEPT;
		errorCode=UF_ATTR_cycle(object,&indx,attr_type,title,&value );
		PRTERR(__LINE__);
	}


term:
	return UF_UI_SEL_REJECT;
}


static int no_rivet_attr(    
	tag_t object,
    int type[3],
    void *user_data,
    UF_UI_selection_p_t select)
{
	int
		indx,
		attr_type=UF_ATTR_string;
	char
		title[100];
	UF_ATTR_value_t
		value;
	static char
		rivet_type[300];

	value.value.string=rivet_type;

	indx=0;
	errorCode=UF_ATTR_cycle(object,&indx,attr_type,title,&value );
	PRTERR(__LINE__);
	
	while(indx)
	{
		if(strcmp(title,"RIVET")==0)
			return UF_UI_SEL_REJECT;
		errorCode=UF_ATTR_cycle(object,&indx,attr_type,title,&value );
		PRTERR(__LINE__);
	}


term:
	return UF_UI_SEL_ACCEPT;
}



int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	
		sel_code,
		ret_code,
		num_triples=1;
	UF_UI_mask_t	
		mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);

	sel_code= UF_UI_set_sel_procs(select,rivet_attr,NULL,user_data);

	if( (ret_code==0) && (sel_code==0) )
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;
}



int	path_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	
		sel_code,
		ret_code,
		num_triples=1;
	UF_UI_mask_t	
		mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask
		(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,num_triples,mask_triples);

	sel_code= UF_UI_set_sel_procs(select,no_rivet_attr,NULL,user_data);

	if( (ret_code==0) && (sel_code==0) )
		return UF_UI_SEL_SUCCESS;
	else
		return UF_UI_SEL_FAILURE;
}




void do_it(void)
{
	int		rivet_count;
	tag_t	disp_part,
			rivet_array[3000],
			path_component;

	//  <disp_part>  
	disp_part=UF_PART_ask_display_part();
	if(disp_part==NULL_TAG)
	{
		uc1601("    !!!",1);
		return;
	}

	//1.   <disp_part>  
	//2.   ,      
	//     <UF_UI_select_with_class_dialog>
	//      <component_init_proc>
	//    <rivet_attr>  
	//    <rivet>
	//
label_select:
	//  ,     
	{
		char*	message	="    ";
		char*	title	="    ";
		int		scope	=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY,
				count,i,response;
		tag_p_t	object;

		errorCode=UF_UI_select_with_class_dialog
			(message,title,scope,component_init_proc,NULL,&response,&count,&object);
		if(errorCode==1105012)
			uc1601("  !!!",1);
		PRTERR(__LINE__);

		switch(response)
		{

		case	UF_UI_BACK:
			FREE_OBJ(object);
			goto label_select;

		case	UF_UI_CANCEL:
			FREE_OBJ(object);
			goto term;

		case	UF_UI_OK:
			break;
		}

		//   
		if(count<=0)
		{
			uc1601("   !!!",1);
			goto label_select;
		}
		
		//   
		for(i=0;i<count;i++)
			rivet_array[i]=object[i];
		rivet_count=count;

		//      
		FREE_OBJ(object);

	}

	
	//1.	  <disp_part>  
	//2.	  ,      
	//     <UF_UI_select_with_class_dialog>
	//      <component_init_proc>
	//    <rivet_attr>  
	//    <rivet>
	//3.	  - ,      
	//     <UF_UI_select_with_single_dialog>
	//      <path_init_proc>
	//    <no_rivet_attr>  
	//    <rivet>


	//  - , 
	//    
	{
		char*	message	="  - ";
		char*	title	="  - ";
		int		scope	=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY,
				response;
		tag_t	object,view;
		double	cursor[3];

		errorCode=UF_UI_select_with_single_dialog
			(message,title,scope,path_init_proc,NULL,&response,&object,cursor,&view);
		
		switch(response)
		{
		case	UF_UI_BACK:
			if(object)
			{
				errorCode=UF_DISP_set_highlight(object,0);
				PRTERR(__LINE__);
				goto label_select;
			}
		case UF_UI_CANCEL:
			goto term;
		}

/*
		if(object==NULL_TAG)
			;
*/		
		path_component=object;
		
		errorCode=UF_DISP_set_highlight(object,0);
		PRTERR(__LINE__);

	}



	//1.	  <disp_part>  
	//2.	  ,      
	//     <UF_UI_select_with_class_dialog>
	//      <component_init_proc>
	//    <rivet_attr>  
	//    <rivet>
	//3.	  - ,      
	//     <UF_UI_select_with_single_dialog>
	//      <path_init_proc>
	//    <no_rivet_attr>  
	//    <rivet>
	//4.	     


	struct comp_data
	{
		char  part_name[ 256 + 1 ];			//Output Name of part 
		char  refset_name[ 30 + 1 ];		//Output Name of the reference set in use 
		char  instance_name[ ( 128 + 1 )];	//Output name of instance 
		double  origin[ 3 ];				//Output Position of component 
		double  csys_matrix[ 6 ];			//Output Coordinate System Matrix 
	};


	struct	comp_data	comp_data_array[3000];


	//   
	{
		int	i;	
		char part_name[ 256 + 1 ]; 
		char refset_name[ 30 + 1 ]; 
		char instance_name[ ( 128 + 1 ) ];
		double origin[ 3 ];
		double csys_matrix[ 9 ];
		double transform[ 4 ][ 4 ];

		for(i=0;i<rivet_count;i++)
		{

			errorCode=UF_ASSEM_ask_component_data 
				(rivet_array[i],part_name,refset_name,
				instance_name,origin,csys_matrix,transform);
			PRTERR(__LINE__);

			strcpy(comp_data_array[i].part_name,part_name);
			strcpy(comp_data_array[i].refset_name,refset_name);
			strcpy(comp_data_array[i].instance_name,instance_name);
			UF_VEC3_copy(origin,comp_data_array[i].origin);
			UF_VEC3_copy(csys_matrix,comp_data_array[i].csys_matrix);
			UF_VEC3_copy(csys_matrix+3,comp_data_array[i].csys_matrix+3);
			
		}
	}

	//1.	  <disp_part>  
	//2.	  ,      
	//     <UF_UI_select_with_class_dialog>
	//      <component_init_proc>
	//    <rivet_attr>  
	//    <rivet>
	//3.	  - ,      
	//     <UF_UI_select_with_single_dialog>
	//      <path_init_proc>
	//    <no_rivet_attr>  
	//    <rivet>
	//4.	     
	//5.	  -    
	//


	//     
	{
		int		i;
		tag_t	instance;
		
		for(i=0;i<rivet_count;i++)
		{

			instance=UF_ASSEM_ask_inst_of_part_occ (rivet_array[i]);
			
			errorCode=UF_ASSEM_remove_instance(instance);
			PRTERR(__LINE__);

		}

	}


	//1.	  <disp_part>  
	//2.	  ,      
	//     <UF_UI_select_with_class_dialog>
	//      <component_init_proc>
	//    <rivet_attr>  
	//    <rivet>
	//3.	  - ,      
	//     <UF_UI_select_with_single_dialog>
	//      <path_init_proc>
	//    <no_rivet_attr>  
	//    <rivet>
	//4.	     
	//5.	  -    
	//6.	    - 



	tag_t	path_tag;
	//   - 
	{
		char part_name[ 256 + 1 ]; 
		char refset_name[ 30 + 1 ]; 
		char instance_name[ ( 128 + 1 ) ];
		double origin[ 3 ];
		double csys_matrix[ 9 ];
		double transform[ 4 ][ 4 ];
		

		if(path_component==NULL_TAG)
		{
			path_tag=disp_part;
			goto label_insert;
		}

		errorCode=UF_ASSEM_ask_component_data 
			(path_component,part_name,refset_name,
			instance_name,origin,csys_matrix,transform);
		PRTERR(__LINE__);

		
		path_tag=UF_PART_ask_part_tag(part_name);
		PRTERR(__LINE__);


/*
		errorCode=UF_ASSEM_set_work_part(path_tag);
		PRTERR(__LINE__);
*/
	}

	
	//1.	  <disp_part>  
	//2.	  ,      
	//     <UF_UI_select_with_class_dialog>
	//      <component_init_proc>
	//    <rivet_attr>  
	//    <rivet>
	//3.	  - ,      
	//     <UF_UI_select_with_single_dialog>
	//      <path_init_proc>
	//    <no_rivet_attr>  
	//    <rivet>
	//4.	     
	//5.	  -    
	//6.	    - 
	//7.	     
	//   <rivet>  
	//---------------  --------------------------------

label_insert:
	//   
	{
		char  part_name[ 256 + 1 ];			//Output Name of part 
		char  refset_name[ 30 + 1 ];		//Output Name of the reference set in use 
		char  instance_name[ ( 128 + 1 )];	//Output name of instance 
		double  origin[ 3 ];				//Output Position of component 
		double  csys_matrix[ 6 ];			//Output Coordinate System Matrix 

		int	i,
			layer=0;

		UF_PART_load_status_t
			error_status;
		
		tag_t
			instance;

		char*	
			title="RIVET";

		char*
			rivet_type="work";

		UF_ATTR_value_t 
			value;
		
		value.type = UF_ATTR_string;
		value.value.string = rivet_type;
        		
		
		

		for(i=0;i<rivet_count;i++)
		{

			strcpy(part_name,comp_data_array[i].part_name);
			strcpy(refset_name,comp_data_array[i].refset_name);
			strcpy(instance_name,comp_data_array[i].instance_name);
			UF_VEC3_copy(comp_data_array[i].origin,origin);
			UF_VEC3_copy(comp_data_array[i].csys_matrix,csys_matrix);
			UF_VEC3_copy(comp_data_array[i].csys_matrix+3,csys_matrix+3);
			errorCode=UF_ASSEM_add_part_to_assembly
				(path_tag,part_name,refset_name,instance_name,origin,
				csys_matrix,layer,&instance,&error_status);
			PRTERR(__LINE__);
			errorCode=UF_PART_free_load_status(&error_status);
			
			tag_t	child_part;

			//   
			child_part=UF_ASSEM_ask_child_of_instance(instance);
	
			//  rivet=[work]  
			errorCode=UF_ATTR_assign(child_part,title,value);
			PRTERR(__LINE__);

		}
	}



term:
	fflush(prterr);
	return;
}





/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{

	//   
	struct	tm*		newtime;
	time_t			aclock,
					start_time,
					finish_time;
	double			work_time;
	int				min,sec;


	time(&start_time);

	//  prterr.txt    D:
	//
	if((prterr=fopen("D:\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    D:\\",1);
		goto label_clock;
	}

	//  prterr.txt   TEMP
	//
	if((prterr=fopen("C:\\TEMP\\prterr.txt","w"))!=NULL)
	{
		uc1601("  <prterr.txt>    D:\\TEMP\\",1);
		goto label_clock;
	}

	//  <prterr.txt>      
	//
	uc1601("     <prterr.txt>",1);
	return;

label_clock:
	time(&aclock);
	newtime=localtime(&aclock);
	fprintf(prterr,"<move_instance> STARTED		line=%d\n\n",__LINE__);
	fprintf(prterr,"    %s\n\n",asctime(newtime));
	fflush(prterr);

	errorCode=UF_initialize();PRTERR(__LINE__);

	do_it();

	errorCode=UF_terminate();PRTERR(__LINE__);

term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"<move_instance> FINISHED		line=%d\n\n",__LINE__);
	fprintf(prterr,"work_time is	%u min	%u sec\n",min,sec);
	fflush(prterr);
	fclose(prterr);
	if(UF_is_initialized())
		UF_terminate();
	return;
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}
